part of flutter_widget_model;

@immutable
abstract class ValueModel<T extends Object> extends Model<T> {
  final T initialValue;
  const ValueModel([T initialValue])
      : this.initialValue = initialValue,
        super();

  /// Retrieve the data obtained from the model.
  ///
  /// Normally, you will get the data from the [build] method.
  @protected
  T get state {
    Future<IPath> task = this.createTask();
    if (task == null) return this.build() ?? this.initialValue;
    try {
      use(_ModelHook(this, task));
    } on AssertionError {}
    return this.build() ?? this.initialValue;
  }
}
